﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleAttributes
{
    /// <remarks>
    /// Класс, создаваемый тремя авторами
    /// </remarks>
    [History("В. Биллиг", "30.03.2009", 
        comment = "Совместный проект. Будем работать!")]
    [History("М. Дехтярь", "30.03.2009",
        comment = "Проект: Наш класс")]
    [History("И. Муссикаев", "30.03.2009",
        comment = "Три автора")]
    class OurClass
    {
        
        /// <remarks> Метод 1</remarks>        
        [History("И. Муссикаев", "3.04.2009",
         comment = "Первый вариант алгоритма")]
        [History("И. Муссикаев", "7.04.2009",
        comment = "Улучшеный вариант")]
        public void First()
        {
        } 
        /// <summary>
        /// Метод 2
        /// </summary>
        [History("М. Дехтярь", "3.04.2009",
        comment = "Первый вариант алгоритма")]
        [History("М. Дехтярь", "7.04.2009",
        comment = "Улучшение характеристик сложности")]
        public void Second()
        {
        }
         /**
         * <summary>Третий метод. Лучший из всех методов. </summary>
         * */
        /// <exception cref = "OurClassException">
        /// Исключение возникает после дождика в четверг!
        /// Оно будет перехвачено и обработано.
        /// </exception>       
        [History("В. Биллиг", "2.04.2009",
        comment = "Первый вариант реализации алгоритма")]
        [History("В. Биллиг", "5.04.2009",
                comment = "Изменение спецификаций")]
        public void Third()
        {
            const string message = "Дождь в четверг!";
            const string result = "Хорошо собирать грибы!";

            try
            {
                bool rainInThursday = true;
                if (rainInThursday) throw (new OurClassException(message));
            }
            catch (OurClassException e)
            {
                Console.WriteLine(e.Message);
                Console.WriteLine(result);
            }
        }
    }
    class OurClassException : Exception
    {
        public OurClassException()
            : base()
        {
        }
        /// <summary>
        /// Это конструктор класса исключений
        /// </summary>
        /// <param name="message"> сообщение о причине исключения</param>
        public OurClassException(string message)
            : base(message)
        {
        }
        public OurClassException(string message, Exception e)
            : base(message, e)
        {
        }
    }
}
