﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Reflection;
using System.Diagnostics;
using System.ComponentModel;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;


namespace ConsoleAttributes
{
    class Testing
    {
        /// <summary>
        /// Тестирование процесса приема на работу 
        /// </summary>
        public void TestJob()
        {
            Prog_Properties pattern = Prog_Properties.C_sharp |
                Prog_Properties.Web;
            Console.WriteLine("Требования, заданные образцом:" +
                " Знание языка С# и Web технологии");

            int n = 10;
            Job mys = new Job(n);
            mys.FormCands();
            Prog_Properties[] cand = mys.GetCands();
            //string[] strCand = mys.GetStrCands();
            for (int i = 0; i < n; i++)
            {
                Console.WriteLine("Свойства кандидата[{0}] - {1}",
                    i, cand[i].ToString());
                //Console.WriteLine(strCand[i]);
            }           
        } 
        public void TestAttr()
        {
             // This variable holds the amount of indenting that 
        // should be used when displaying each line of information.
        Int32 indent = 0;
        // Display information about the EXE assembly.
        Assembly a = System.Reflection.Assembly.GetExecutingAssembly();
        Display(indent, "Assembly identity={0}", a.FullName);
        Display(indent+1, "Codebase={0}", a.CodeBase);

        // Display the set of assemblies our assemblies reference.

        Display(indent, "Referenced assemblies:");
        foreach (AssemblyName an in a.GetReferencedAssemblies() )
        {
             Display(indent + 1, "Name={0}, Version={1}, Culture={2}, PublicKey token={3}", an.Name, an.Version, an.CultureInfo.Name, (BitConverter.ToString (an.GetPublicKeyToken())));
        }
        Display(indent, "");

        // Display information about each assembly loading into this AppDomain.
        foreach (Assembly b in AppDomain.CurrentDomain.GetAssemblies())
        {
            Display(indent, "Assembly: {0}", b);

            // Display information about each module of this assembly.
            foreach ( Module m in b.GetModules(true) )
            {
                Display(indent+1, "Module: {0}", m.Name);
            }

            // Display information about each type exported from this assembly.

            indent += 1;
            foreach ( Type t in b.GetExportedTypes() )
            {
                Display(0, "");
                Display(indent, "Type: {0}", t);

                // For each type, show its members & their custom attributes.

                indent += 1;
                foreach (MemberInfo mi in t.GetMembers() )
                {
                    Display(indent, "Member: {0}", mi.Name);
                    DisplayAttributes(indent, mi);

                    // If the member is a method, display information about its parameters.

                    if (mi.MemberType==MemberTypes.Method)
                    {
                        foreach ( ParameterInfo pi in ((MethodInfo) mi).GetParameters() )
                        {
                            Display(indent+1, "Parameter: Type={0}, Name={1}", pi.ParameterType, pi.Name);
                        }
                    }

                    // If the member is a property, display information about the property's accessor methods.
                    if (mi.MemberType==MemberTypes.Property)
                    {
                        foreach ( MethodInfo am in ((PropertyInfo) mi).GetAccessors() )
                        {
                            Display(indent+1, "Accessor method: {0}", am);
                        }
                    }
                }
                indent -= 1;
            }
            indent -= 1;
         }

       }
        // Displays the custom attributes applied to the specified member.
    public static void DisplayAttributes(Int32 indent, MemberInfo mi)
    {
        // Get the set of custom attributes; if none exist, just return.
        object[] attrs = mi.GetCustomAttributes(true);
        if (attrs.Length==0) {return;}

        // Display the custom attributes applied to this member.
        Display(indent+1, "Attributes:");
        foreach ( object o in attrs )
        {
            Display(indent+2, "{0}", o.ToString());
        }
    }

    // Display a formatted string indented by the specified amount.
    public static void Display(Int32 indent, string format, params object[] param) 

    {
        Console.Write(new string(' ', indent*2));
        Console.WriteLine(format, param);
    }
    public void TestGetAttributes()
    {
        //Получить атрибуты класса Attribute
        Type clstype = typeof(Job);
        MemberInfo minfo = clstype.GetMethod("Standard");
        
        Module module = clstype.Module;
        Attribute[] atrs = Attribute.GetCustomAttributes(module, true);
        Console.WriteLine("Доступ к атрибутам через класс Attribute!");
        foreach (Attribute a in atrs)
            Console.WriteLine(a.ToString());

        atrs = Attribute.GetCustomAttributes(minfo);
        Console.WriteLine("Доступ к атрибутам через класс Attribute!");
        foreach (Attribute a in atrs)
            Console.WriteLine(a.ToString());
        Console.WriteLine("Доступ к атрибутам через класс Module!");
        object[] atrs1 = module.GetCustomAttributes(false);
        foreach (Attribute a in atrs1)
            Console.WriteLine(a.ToString());
    }
    /// <summary>
    /// Извлечение атрибутов класса
    /// </summary>
    public void TestTwoMeans()
    {
        Type clstype = typeof(Prog_Properties);
        // Получить атрибуты перечисления,
        //используя класс Attribute
        Console.WriteLine("Класс Attribute!");
        if (Attribute.IsDefined(clstype, 
                typeof(FlagsAttribute), false))
        {
            Attribute att = Attribute.GetCustomAttribute(clstype,
            typeof(FlagsAttribute));
            Console.WriteLine(
                "У класса Prog_Properties есть атрибут {0}", att);
        }            
                  
        else
            Console.WriteLine("У класса Prog_Properties нет атрибута Flags");

        Attribute[] attrs = Attribute.GetCustomAttributes(
            clstype, false);
        foreach (Attribute attr in attrs)        
            Console.WriteLine(attr);
  
        // Получить атрибуты перечисления,
        //используя класс Type
        Console.WriteLine("Класс Type!");
        if(clstype.IsDefined(typeof(FlagsAttribute), false))
            Console.WriteLine("У класса Prog_Properties есть атрибут Flags");
        else
            Console.WriteLine("У класса Prog_Properties нет атрибута Flags");
      
        object[] attrsob = clstype.GetCustomAttributes(false);
        foreach (Attribute attr in attrsob)       
            Console.WriteLine(attr);
    }
    public void TestGetEntityAttributes()
    {
        //Получение атрибутов сборки и модуля
        Type clstype = typeof(Prog_Properties);
        Assembly projectAssembly = clstype.Assembly;
        Module projectModule = clstype.Module;
        Attribute[] assemblyAttributes =
            Attribute.GetCustomAttributes(projectAssembly);
        Console.WriteLine("Атрибуты сборки");
        foreach (Attribute attr in assemblyAttributes)
            Console.WriteLine(attr);

        Attribute[] moduleAttributes =
            Attribute.GetCustomAttributes(projectModule);
        Console.WriteLine("Атрибуты модуля");
        foreach (Attribute attr in moduleAttributes)
            Console.WriteLine(attr);
        //Получение атрибутов метода и возвращаемого значения
        Type typeJob = typeof(Job);
        MethodInfo classMethod = typeJob.GetMethod("GetStrCands");

        Attribute[] methodAttributes =
            Attribute.GetCustomAttributes(classMethod);
        Console.WriteLine("Атрибуты метода");
        foreach (Attribute attr in methodAttributes)
            Console.WriteLine(attr);

        Console.WriteLine("Атрибуты вовращаемого значения");
       ParameterInfo returnMethod = classMethod.ReturnParameter;
       foreach(Attribute attr in returnMethod.GetCustomAttributes(false))
           Console.WriteLine(attr);

        //Работа с атрибутом Description
       Console.WriteLine("Получение параметров атрибута Description");

       DescriptionAttribute des;
       MemberInfo specMethod = typeJob.GetMethod("GetStrCands");
       if (Attribute.IsDefined(specMethod, typeof(DescriptionAttribute)))
       {
           des = (DescriptionAttribute)Attribute.GetCustomAttribute(specMethod,
               typeof(DescriptionAttribute));
           Console.WriteLine(des.Description);
       }
       ParameterInfo retMethod = classMethod.ReturnParameter;
       des = (DescriptionAttribute)Attribute.GetCustomAttribute(retMethod,
             typeof(DescriptionAttribute));
       Console.WriteLine(des.Description);
    }
    public void TestTeacherAndStudents()
    {
        string teacherName = "Иванов Л.Д.";
        Teacher teacher;
        Student[] students = new Student[3];
        string[] studNames = 
        {"Зайцев Г.Ю.","Гулевич С.А.","Маргулис В.А."};
        teacher = new Teacher(teacherName, students);
        students[0] = new Student(studNames[0], teacher);
        students[1] = new Student(studNames[1], teacher);
        students[2] = new Student(studNames[2], teacher);
        students[0].Topic = "thema0";
        students[1].Topic = "thema1";
        students[2].Topic = "thema2";
        Console.WriteLine("Темы студентов");
        for (int i = 0; i < 3; i++)
            Console.WriteLine("Студент {0}, тема: {1} ",
                studNames[i], students[i].Topic);
       
        Stream tasFile, satFile;
        tasFile = File.Create("teach1.bin");
        satFile = File.Create("teach2.bin");
        BinaryFormatter bif = new BinaryFormatter();
        bif.Serialize(tasFile, teacher);
        bif.Serialize(satFile, students[0]);
        tasFile.Close();
        satFile.Close();
        Console.WriteLine("Темы запомнили!");
        Console.WriteLine("Меняем темы!");
        students[0].Topic = "thema7";
        students[1].Topic = "thema8";
        students[2].Topic = "thema9";
        teacher = null;
        for (int i = 0; i < 3; i++)
            Console.WriteLine("Студент {0}, тема: {1} ",
                studNames[i], students[i].Topic);
        Console.WriteLine("Десериализация. Восстанавливаем состояние");
        tasFile = File.Open("teach1.bin",FileMode.Open, FileAccess.Read);
            
        bif = new BinaryFormatter();
        teacher = (Teacher)bif.Deserialize(tasFile);
        students = teacher.Students;
        for (int i = 0; i < 3; i++)
            Console.WriteLine("Студент {0}, тема: {1} ",
                studNames[i], students[i].Topic);
    }
    public void TestConditional()
    {
        Console.WriteLine("Demo or Profi?");
        ClassDemo demo = new ClassDemo();
        demo.ClientMethod("");        
    }
    public void TestOurClass()
    {
        
        //История разработки класса
        Console.WriteLine("История разработки класса");
        Type clstype = typeof(OurClass);
        Attribute[] attrs;
        HistoryAttribute history;
        attrs = Attribute.GetCustomAttributes(clstype);
        foreach(Attribute attr in attrs)
        {
            history = attr as HistoryAttribute;
            if (history != null)
                Console.WriteLine("автор: {0}", history.Author);
                Console.WriteLine(" дата начала разработки: {0} ",
                        history.Date);
                Console.WriteLine("комментарий: {0} ",
                    history.comment);
        }
        Console.WriteLine("История разработки методов");
        MethodInfo[] methods = clstype.GetMethods();
        foreach (MethodInfo method in methods)
        {
            attrs = Attribute.GetCustomAttributes(method);
            foreach(Attribute attr in attrs)
            {
                history = attr as HistoryAttribute;
                if (history != null)
                Console.WriteLine("Метод: {0} ", method.Name);
                Console.WriteLine("автор: {0}", history.Author);
                Console.WriteLine(" дата начала разработки: {0}",
                        history.Date);
                Console.WriteLine("комментарий: {0} ", 
                        history.comment);
            }            
        }
        OurClass our = new OurClass();
        our.First();
        our.Second();
        our.Third();
    }
    
  }   
} 
