﻿using System;
using System.Reflection;
using System.ComponentModel;
using ConsoleGetAttributes;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;



// Assign some attributes to the module.
[module:Description("A sample description")]

// Set the module's CLSCompliant attribute to false
// The CLSCompliant attribute is applicable for /target:module.
[assembly:CLSCompliant(false)]

namespace CustAttrs2CS {
    class DemoClass {
        static void Main(string[] args) {
            TestSerialize();
            
            Type clsType = typeof(ClassDemo);
            // Get the Module type to access its metadata.
            Module module = clsType.Module;
            Attribute[] attrs = Attribute.GetCustomAttributes(module, false);
            foreach (Attribute attr in attrs)
                Console.WriteLine(attr);

            // Iterate through all the attributes for the module.
            foreach(Attribute attr in Attribute.GetCustomAttributes(module)) {
                // Check for the Description attribute.
                if (attr.GetType() == typeof(DescriptionAttribute))
                    Console.WriteLine("Module {0} has the description " +
                        "\"{1}\".", module.Name, 
                        ((DescriptionAttribute)attr).Description);
                // Check for the CLSCompliant attribute.
                else if (attr.GetType() == typeof(CLSCompliantAttribute))
                    Console.WriteLine("Module {0} {1} CLSCompliant.",
                        module.Name,
                        ((CLSCompliantAttribute)attr).IsCompliant ? 
                            "is" : "is not");
            }
        }
        static void TestSerialize()
        {
            ClassDemo demo = new ClassDemo();
            Stream myFile = File.Create("MyFile.bin");
            BinaryFormatter bif = new BinaryFormatter();
            bif.Serialize(myFile, demo);
            myFile.Close();
        }
    }
}


